    Program Random_Select;

    uses
      Dos;
      {$I Parsing}
    const
      note : String[55] = ' Compiled by David Adamson ';
    type
      List = array [1..500] of string[12];

    var
      dirfile     : list;
      Upper, R, S : integer;
      Data2       : String[4];
      code        : word;
      P1, P2, P3  : PathStr;
      D1, D2, D3  : DirStr;
      N1, N2, N3  : NameStr;
      E1, E2, E3  : ExtStr;


function FileExists(FileName: string) : Boolean;
  { Returns True if file exists; otherwise, it returns False. }

  var
    DirInfo: SearchRec;
  begin
    FindFirst(FileName, 0, DirInfo );
    FileExists := (DosError = 0);
  end;


  procedure Load_Dir(var dirfile : list; var DirCount : integer);

    var
      DirInfo: SearchRec;

    begin
      DirCount := 0;
      FindFirst(Parameter(1), 0, DirInfo);         { Read in Directory }
      while (DosError = 0) and (DirCount <= 500) do
        begin
          DirCount := DirCount + 1;
          dirfile[DirCount] := DirInfo.Name;
          FindNext(DirInfo);
       end;                                               {while}
  end;                                                    {procedure}

  Procedure Help;
     begin
       WriteLn(' This is a program to select a random text file from a ');
       WriteLn(' directory, and copy it to a new directory/file name.  ');
       WriteLn(' Syntax:  Random input_wildcards  output_file_name     ');
       WriteLn(' Example: Random C:\QBBS\1\*.TXT  C:\QBBS\TEXT\WELCOME.ASC');
       Halt(1);
     end;



procedure blockcopy(InSpec, Outspec : string; var Code: word);

label
   CloseFiles;

const
   BuffSize = 8192;                           {May be changed.}

var
   InFile, OutFile         : file;
   NumIn, NumOut, J, K     : word;
   TotalRead, TotalWritten : longint;
   Buffer: array[1..BuffSize] of char;

begin
   TotalRead    := 0;
   TotalWritten := 0;
   assign(InFile, InSpec);
   assign(OutFile, OutSpec);
   {$I-}
   reset(InFile, 1);
   Code := ioresult;
   if Code <> 0 then exit;
   rewrite(OutFile, 1);
   Code := ioresult;
   if Code <> 0 then
      begin
         close(InFile);
         exit
      end;
   repeat
      blockread(InFile, Buffer, sizeof(Buffer), NumIn);
      Code := ioresult;
      if Code <> 0 then goto CloseFiles;
      inc(TotalRead, NumIn);
      blockwrite(OutFile, Buffer, NumIn, NumOut);
      Code := ioresult;
      if Code <> 0 then goto CloseFiles;
      inc(TotalWritten, NumOut);
      if NumOut <> NumIn then
         begin
            Code := 101;
            goto CloseFiles
         end
   until
      (NumIn = 0) or (NumOut <> NumIn);
CloseFiles:
   if Code = 0 then
      begin
         close(InFile);
         Code := ioresult;
         close(OutFile);
         if Code = 0 then
            Code := ioresult
      end
   else
      begin
         close(InFile);
         close(OutFile)
      end;
   {$I+}
   If SwitchThere('T') then
    writeln('Input=', TotalRead, ', Output=', TotalWritten,' Code= ',code)                       {Mod. #2}
end;

(* Main *)

    begin
      if switchthere('?') or switchthere('H') then
       Help;
      if Parameters <= 1 then
       Help;

      FSplit(FExpand(Parameter(1)), D1, N1, E1);
      FSplit(FExpand(Parameter(2)), D2, N2, E2);

(*  Make random file selection  *)

      Load_Dir(dirfile, Upper);
      Randomize;
      if Upper > 500 then Upper := 500;
      if Upper <= 1 then
       begin
        Write(' Less than two input files match the input wildcard');
        writeln(' specification. ',#13,#10,' - ');
        Help;
       end;
      R := Random(Upper) +1;
       if DirFile[R] = (N2 + E2) then
        begin
         if R <> 1 then
          R := R-1
        else
          R := R+1;
      if SwitchThere('T') then
       writeln('Input DirFile[R] is ',dirfile[r], ' and Output file is ',N2+E2);
       end;
      FSplit(DirFile[R], D3, N3, E3);
      WriteLn('Random file # ',R, ' , ',DirFile[R],' selected out of a total of ',upper);

(*  Copy selection to output file  *)

      BlockCopy(D1 + N3 + E3, D2 + N2 + E2, Code);
      if Code <> 0 then
       begin
        Writeln('Halting with errorlevel: ',code);
        Halt(code);
       end;


 (*  Copy second selection if switch "/2" is used  *)

       Data2 := '.' + UpString(SwitchData('2'));
       If SwitchThere('2')  and (D1 + N3 + Data2 =  D2 + N2 + Data2) then
        begin
         writeln('Output file ',N2 + Data2,' already exists. ');
         Halt(1);
        end;

      if FileExists(D1 + N3 + Data2) and SwitchThere('2') then
       Writeln(N3 + Data2,' selected for second output file ');
      if Not FileExists(D1 + N3 +Data2) and SwitchThere('2') then
       begin
        Writeln(N3 + Data2,' not found for copying to output file.');
        Halt(1);
       end;
       if (SwitchThere('2')) and FileExists(D1 + N3 + Data2) then
        BlockCopy(D1 + N3 + Data2, D2 + N2 + Data2, Code);
       if Code <> 0 then
        begin
         Writeln('Halting with errorlevel: ',code);
         Halt(code);
        end;

(*  END program  *)

      note := note;
      if SwitchThere('T') then
       writeln('Done');
  end.
